<!DOCTYPE html>
<html style='height:100%'>
<head>
    <title>Erachain Explorer</title>
    <link href="/index/libs/bootstrap/3/css/theme.css" rel="stylesheet">
    <script src="/index/libs/jquery/jquery.2.js"></script>
    <script src="/index/libs/bootstrap/3/js/bootstrap.min.js"></script>
    <link href="/index/libs/css/style.css" rel="stylesheet">
    <script src="/index/libs/js/sidebar.js"></script>
    <script src="/index/libs/js/common.js"></script>
    <script src="/index/libs/js/marked.js"></script>
    <script src="/index/libs/js/utils.js"></script>
    <script src="/index/libs/js/explorer.js"></script>
    <script src="/index/libs/js/explorerItems.js"></script>
    <script src="/index/libs/js/explorerAssets.js"></script>
    <script src="/index/libs/js/explorerPersons.js"></script>
    <script src="/index/libs/js/explorerPolls.js"></script>
    <script src="/index/libs/js/explorerStatements.js"></script>
    <script src="/index/libs/js/explorerStatuses.js"></script>
    <script src="/index/libs/js/explorerTemplates.js"></script>
    <script src="/index/libs/js/explorerExchange.js"></script>
    <script src="/index/libs/js/explorerTransactions.js"></script>
    <script src="/index/libs/js/explorerTransactionsTable.js"></script>
    <script src="/index/libs/js/third-party/qrcode.min.js"></script>

    <script src="/index/libs/js/Base58.js" charset="utf-8"></script>

    <link href="/index/libs/css/sidebar.css" rel="stylesheet">

    <style type="text/css">
        body {
            padding-top: 5px;
        }

.ll-blue-bgc {
    background-color: #dadada; // #94e7ff;
    color: #333;
    margin: 0;
    margin-top: -6px;
    //cursor: pointer;
    border: 3px solid transparent;
    box-sizing: border-box;
    outline: none;
    position: relative;
    -webkit-transition: all 0.15s;
    transition: all 0.15s;
    text-align: center;
    vertical-align: middle;
    margin: 0;
    text-decoration: none;
    font-size: 1.2em;
        }

button,
.button {
    cursor: pointer;
    border: 3px solid transparent; /* !important; */
    box-sizing: border-box;
    outline: none;
    padding: 0.1em 1%;
    position: relative;
    /* -webkit-transition: all 0.15s; */
    transition: all 0.15s
}
.button[disabled] {
    opacity: 0.5
}
button:hover, button:active, button:focus,
.button:hover, .button:active, .button:focus {
    text-decoration: none
}
.button.lightblue {
    background-color: #00BCF2
}
.button.lightblue-bgc:hover,
.button.lightblue-bgc:focus,
.button.ll-blue-bgc:focus,
.button.ll-blue-bgc:hover {
    color: #000;
    border: 3px solid #FFF  !important;
}
.button.ll-blue-bgc.active, .button.ll-blue-bgc:active,
.button.lightblue-bgc:active {
    background-color: #aaa  !important;
}
.button.ll-blue-bgc[disabled]:hover,
.button.ll-blue-bgc[disabled]:focus,
.button.lightblue-bgc[disabled]:hover,
.button.lightblue-bgc[disabled]:focus {
    border-color: #00BCF2 !important;
    background-color: #00BCF2
}
.button.blue-bgc:hover,
.button.blue-bgc:focus {
    color: #FFF; /*aliceblue; */
    border: 3px solid #FFF !important;
}
button.blue-bgc:active,
.button.blue-bgc:active {
    background-color: #0066b6
}
button.blue-bgc[disabled]:hover,
button.blue-bgc[disabled]:focus,
.button.blue-bgc[disabled]:hover,
.button.blue-bgc[disabled]:focus {
    border-color: #0078D7;  !important
    background-color: #0078D7
}
button.white-bgc:hover,
button.white-bgc:focus,
.button.white-bgc:hover,
.button.white-bgc:focus {
    border: 3px solid #bfbfbf !important;
}
button.white-bgc:active,
.button.white-bgc:active {
    background-color: #d8d8d8
}
button.white-bgc[disabled]:hover,
button.white-bgc[disabled]:focus,
.button.white-bgc[disabled]:hover,
.button.white-bgc[disabled]:focus {
    border-color: #FFFFFF;
    background-color: #FFFFFF
}

.lightblue-c {
    color: #00BCF2
}
.blue-c {
    color: #0078D7;
}

        .sub-header {
            padding-bottom: 10px;
            border-bottom: 1px solid #eee;
        }

        .navbar-fixed-top {
            border: 0;
            z-index: 9999;
        }

        .sidebar {
            display: none;
        }

        @media (min-width: 768px) {
            .sidebar {
                position: fixed;
                top: 51px;
                bottom: 0;
                left: 0;
                z-index: 1000;
                display: block;
                padding: 20px;
                overflow-x: hidden;
                overflow-y: auto;
                background-color: #f5f5f5;
                border-right: 1px solid #eee;
            }
        }

        .nav-sidebar {
            margin-right: -21px;
            margin-bottom: 20px;
            margin-left: -20px;
        }

        .nav-sidebar > li > a {
            padding-right: 20px;
            padding-left: 20px;
        }

        .nav-sidebar > .active > a,
        .nav-sidebar > .active > a:hover,
        .nav-sidebar > .active > a:focus {
            color: #fff;
            background-color: #428bca;
        }

        .main {
            padding-top: 20px;
        }

        .main-tabs {
            width: 100%;
            padding-top: 5px;
            padding-left: 0px;
            padding-right: 0px;
            background-color: lightgray;
        }

        img.logo-header {
            background-color: transparent;
            height: 100%;
        }

        .col-lg-8 {
            padding-left: 0px;
        }

        @media (min-width: 768px) {
            .main {
                padding-right: 40px;
            }
        }

        .main .page-header {
            margin-top: 0;
        }

        .placeholders {
            margin-bottom: 30px;
            text-align: center;
        }

        .placeholders h4 {
            margin-bottom: 0;
        }

        .placeholder {
            margin-bottom: 20px;
        }

        .placeholder img {
            display: inline-block;
            border-radius: 50%;
        }

        .r-t {
            margin: 0px;
        }

        .r-l {
            margin: 0px;
        }

        span.label.label-default {
            background-color: #fff;
            color: lightgray;
            font-size: 90%;
            line-height: 1;
        }

        span.label.label-default a {
            color: #ddd;
            text-decoration: none;
        }

        a.r-l:hover,
        a.r-l:focus {
            color: #6467FF;
            text-decoration: none;
        }

        .navbar-header {
            width: 110px;
        }

        a.anchor {
            display: block;
            position: relative;
            top: -64px;
            visibility: hidden;
        }
    </style>
    <script type="text/javascript" charset="UTF-8">


        var loading = true;
        var params;

        function getXmlHttp() {
            var xmlhttp;
            try {
                xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
            } catch (e) {
                try {
                    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
                } catch (E) {
                    xmlhttp = false;
                }
            }
            if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
                xmlhttp = new XMLHttpRequest();
            }
            return xmlhttp;
        }

        function getResponseJson(url) {
            var xmlhttp = getXmlHttp()
            xmlhttp.open('GET', url, false);
            xmlhttp.send(null);

            if (xmlhttp.readyState == 4) {
                if (xmlhttp.status == 200) {
                    return JSON.parse(xmlhttp.responseText);
                }
            }
        }

        function asyncAjax(url) {
            var xmlhttp = getXmlHttp()
            xmlhttp.open('GET', url, true);
            loading = true;
            setTimeout(function () {
                if (loading) {
                    document.getElementById('loading').style.display = 'block';
                }
            }, 250);

            xmlhttp.onreadystatechange = function () {
                if (xmlhttp.readyState == 4) {
                    if (xmlhttp.status == 200) {
                        var data = JSON.parse(xmlhttp.responseText);
                        if (Object.keys(data).length > 0) {

                            var type = data.type;
                            var forPrint = parseUrlQuery().print;
                            var dest;
                            if (forPrint) {
                                dest = 'all';
                            } else {
                                dest = 'main';
                            }

                            document.getElementById('Langs').innerHTML = langs(data);

                            if (data.hasOwnProperty('network')) {
                                document.getElementById('network').innerHTML = data.network;
                            }

                            // select searchID in need
                            if (data.hasOwnProperty('search')) {
                                $('#selectID').val(data.search);
                            } else {
                                $('#selectID').val(type);
                            }

                            if (data.hasOwnProperty('search_placeholder')) {
                                $('#q').attr('placeholder', data.search_placeholder);
                            }
                            if (data.hasOwnProperty('search_message')) {
                                $('#q').val(data.search_message);
                            }

                            if (!data.noSearchedElements) {
                                if (type == 'blocks') {
                                    document.getElementById(dest).innerHTML = blocks(data);
                                } else
                                if (type == 'address') {
                                    document.getElementById(dest).innerHTML = address(data);
                                } else
                                if (type == 'addresses') {
                                    document.getElementById(dest).innerHTML = addresses(data);
                                } else
                                if (type == 'peers') {
                                    document.getElementById(dest).innerHTML = peers(data);
                                } else
                                if (type == 'exchange') {
                                    document.getElementById(dest).innerHTML = exchange(data);
                                } else
                                if (type == 'order') {
                                    document.getElementById(dest).innerHTML = order(data);
                                } else
                                if (type == 'transactions') {
                                    document.getElementById(dest).innerHTML = transactions(data);
                                } else
                                if (type == 'tx') {
                                    document.getElementById(dest).innerHTML = tx(data);
                                } else
                                if (type == 'templates') {
                                    document.getElementById(dest).innerHTML = templates(data);
                                } else
                                if (type == 'template') {
                                    document.getElementById(dest).innerHTML = template(data, forPrint);
                                } else
                                if (type == 'statement') {
                                    document.getElementById(dest).innerHTML = statement(data);
                                } else
                                if (type == 'owners') {
                                    document.getElementById(dest).innerHTML = owners(data);
                                } else
                                if (type == 'persons') {
                                    document.getElementById(dest).innerHTML = persons(data);
                                } else
                                if (type == 'person') {
                                    document.getElementById(dest).innerHTML = person(data, forPrint);
                                } else
                                if (type == 'person_asset') {
                                    document.getElementById(dest).innerHTML = person_asset(data);
                                } else
                                if (type == 'person_status') {
                                    document.getElementById(dest).innerHTML = person_status(data);
                                } else
                                if (type == 'aTs') {
                                    document.getElementById(dest).innerHTML = aTs(data)
                                } else
                                if (type == 'polls') {
                                    document.getElementById(dest).innerHTML = polls(data)
                                } else
                                if (type == 'poll') {
                                    document.getElementById(dest).innerHTML = poll(data, forPrint)
                                } else
                                if (type == 'assets') { // list and for search
                                    document.getElementById(dest).innerHTML = assets(data);
                                } else
                                if (type == 'asset') { // for one Asset
                                    document.getElementById(dest).innerHTML = asset(data, forPrint);
                                } else
                                if (type == 'trades') {
                                    document.getElementById(dest).innerHTML = trades(data)
                                } else
                                if (type == 'search') {
                                    document.getElementById(dest).innerHTML = search(data);
                                } else
                                if (type == 'statuses') {
                                    document.getElementById(dest).innerHTML = statuses(data);
                                } else
                                if (type == 'status') {
                                    document.getElementById(dest).innerHTML = status(data, forPrint);
                                } else
                                if (type == 'block') {
                                    document.getElementById(dest).innerHTML = block(data);
                                } else
                                ///if (type == 'mainQuery')
                                {
                                    document.getElementById(dest).innerHTML = mainQuery(data);
                                    genFilterUrlForAll();
                                    genFilterUrl();
                                    if (window.location.hash) {
                                        window.location.href = window.location.hash;
                                    }
                                }
                            }
                        }
                        document.getElementById('loading').style.display = 'none';
                        loading = false;

                    }
                }
            }
            xmlhttp.send(null);
        }

        function langs(data) {
            //key =0;
            output = '';
            for (key in data.Lang) {

                output += '	<option value ="' + data.Lang[key].ISO + '"';
                a = params['lang'];
                b = data.Lang[key].ISO;
                if (a == b) {


                    output += ' selected ';
                }
                output += '>' + data.Lang[key].name + '</option>';

            }

            return output;
        }


        function secToFine(time, lastBlock) {
            time = Math.floor(time / 1000);

            var mins = ~~(time / 60);
            var secs = time % 60;

            // Hours, minutes and seconds
            var hrs = ~~(time / 3600);
            var mins = ~~((time % 3600) / 60);
            var secs = time % 60;

            ret = "";

            if (hrs > 0)
                ret += " " + hrs + " " + (hrs > 1 ? lastBlock.Label_hours : lastBlock.Label_hour);

            ret += " " + mins + " " + (mins > 1 ? lastBlock.Label_mins : lastBlock.Label_min);
            ret += " " + secs + " " + lastBlock.Label_secs;
            return ret;
        }

        function addCommas(str) {
            if (str == null) return "";
            strbuf = str.toString();
            if (strbuf.indexOf('.') == -1) {
                return strbuf.replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, '$1,');
            }
            return strbuf.replace(/(\d)(?=(\d\d\d)+([^\d]))/g, '$1,');
        }

        function aTs(data) {
            var output = '';

            output += lastBlock(data.lastBlock);

            output += '<table id=blocks BORDER=0 cellpadding=15 cellspacing=0 width="680">';
            output += '<tr><td>';

            output += '<center><h3>AT Accounts</h3>';

            for (key in data.aTs) {

                output += '<table class="tiny table table-striped" style="border: 1px solid #ddd;"><tr bgcolor="f1f1f1"><td>';

                output += '<table width="100%">';

                output += '<tr><td> ';

                output += '<b><a href=?address=' + key + get_lang() + '>' + key + '</a></td>';

                output += '<td align=right>';

                if (data.aTs[key].accountBalance != '0.00000000') {
                    output += '<b>';
                }
                output += addCommas(data.aTs[key].accountBalance) + ' ERA';

                output += '</table>';

                output += '<tr><td>';
                output += '<table width="100%"><tr>'

                output += '<td>';
                output += '<b>Name: </b>' + data.aTs[key].name;
                output += '<br><b>Creator:</b> <a href=?address=' + data.aTs[key].creator + get_lang() + '>' + data.aTs[key].creator + '</a>';
                output += '<br><b>AT Type:</b> ' + data.aTs[key].type;

                output += '<br><b>Description:</b> ' + fformat(data.aTs[key].description);
                output += '<br><b>Tags:</b> ' + escapeHtml(wordwrap(data.aTs[key].tags, 80, '\n', true));
                //output += '<br><b>Dead:</b> ' + data.aTs[key].state.dead;
                //output += '<br><b>Frozen:</b> ' + data.aTs[key].state.frozen;
                output += '</td>';

                output += '</tr></table>';

                output += '</table>';

            }

            return output;
        }


        function peers(data) {
            var output = '';

            if (data.hasOwnProperty('error')) {
                return '<h2>' + data.error + '</h2>';
            }

            output += lastBlock(data.lastBlock);

            output += '<table id=blocks BORDER=0 cellpadding=15 cellspacing=0 width="">';
            output += '<tr><td align=left>';

            output += '<table id=blocks BORDER=0 cellpadding=15 cellspacing=0 width="1180"  class="tiny table table-striped" style="border: 1px solid #ddd;">';
            output += '<tr><td><b>' + data.Label_No + '<td><b>' + data.Label_IP + ' <td><b>' + data.Label_Height + '<td><b>' + data.Label_Ping_mc + '<td><b>' + data.Label_Reliable + '<td><b>' + data.Label_Initiator + '<td><b>' + data.Label_Finding_ago + '<td><b>' + data.Label_Online_Time + '<td><b>' + data.Label_Version;

            minHeight = (data.maxHeight <= 20) ? 1 : data.maxHeight - 20;
            for (var i  in data.Peers) {
                output += '<tr><td>' + i;
                output += '<td>' + data.Peers[i].IP + '<td>' + data.Peers[i].Height + '<td>' + data.Peers[i].Ping_mc;
                output += '<td>' + data.Peers[i].Reliable + '<td>' + data.Peers[i].Initiator;
                output += '<td>' + data.Peers[i].Finding_ago + '<td>' + data.Peers[i].Online_Time + '<td>' + data.Peers[i].Version;
            }

            output += '<tr><td colspan=4>';
//	if(data.rowCount != data.lastBlock.height)
//	{
//		if(data.rowCount < data.start + 20)
//		{
//			output += '<a href=?startBlock='+(data.lastBlock.height)+get_lang()+'>'+data.Label_Later;
//		}
//		else
//		{
//			output += '<a href=?startBlock='+(data.maxHeight+21)+get_lang()+'>'+data.Label_Later;
//		}
//	}

//	output += '<td colspan=4 align=right>';
//	if(minHeight > 1) {
//		output += '<a href=?startBlock='+(data.maxHeight-21)+get_lang()+'>'+data.Label_Previous;
//	}

            return output;
        }

        function addresses(data) {

            var output = lastBlock(data.lastBlock);
            //output += data.message;

            return output;

        }

        function address(data) {

            var output ='';

            if (data.hasOwnProperty('error')) {
                output += '<h2>' + data.error + '</h2>';
                output += '<h4>for Help use blockexplorer.json</h4>';
                return output;
            }

            output += '<table width="1280" border=0><tr><td align=left>';
            if (data.hasOwnProperty('person')) {

                output += '<tr><td><br><img src="/apiperson/image/' +
                    data.person_key +
                    '" width="100"/></td><td style ="padding-left:20px">';
                output += '<td><font size="+1">' +
                    data.Label_account + ': <a href="?address=' +
                    data.address + get_lang() + '">' + data.address + '</a><br>';
                output += data.Label_person_name + ': <a href ="?person=' +
                    data.person_key + get_lang() + '">[' + data.person_key + ']' + data.person + '</a>';
                if ('registered' in data) {
                    output += '<br>' + data.Label_registered + ': <b>' +
                        data.registered + '</b>, ' + data.Label_certified +
                        ': <b>' + data.certified + '</b>';
                }
                output += '</font></tr>';

            } else {

                output += '<br><br>';
                output += '<font size="+1">' + data.Label_account +
                    ': <a href="?address=' + data.address + get_lang() +
                    '">' + data.address + '</a></font>';
            }

            output += '</table>';

            if (!data.Balance) {
                // при долгом ответе данные пустые и сайт валится
               output += 'Data unavailable. Try late!';
               return output;
            }

            output += '<table width="1280" border=0><tr><td align=left>';

            output += '<span style="font-size:1.2em">';

            output += data.Balance.Label_Balance_table;

            if (false) {
                // убреме пока переключение по сторонам
                if (data.Balance.side == '1')
                    output +=  ': &nbsp&nbsp <span style="font-size:1.2em; color:#0cb70c"> &nbsp&nbsp ' + data.Balance.Label_TotalDebit + '</span></b>';
                else
                    output +=  ': &nbsp&nbsp <a href ="?address=' + data.address + '&side=1' + get_lang() + '">' + data.Balance.Label_TotalDebit + '</a>';

                if (data.Balance.side == '2')
                    output +=  ' &nbsp&nbsp <span style="font-size:1.2em; color:#0cb70c"> &nbsp&nbsp ' + data.Balance.Label_Left + '</span></b>';
                else
                    output +=  ' &nbsp&nbsp <a href ="?address=' + data.address + '&side=2' + get_lang() + '">' + data.Balance.Label_Left + '</a>';

                if (data.Balance.side == '3')
                    output +=  ' &nbsp&nbsp <span style="font-size:1.2em; color:#0cb70c"> &nbsp&nbsp ' + data.Balance.Label_TotalCredit + '</span></b>';
                else
                    output +=  ' &nbsp&nbsp <a href ="?address=' + data.address + '&side=3' + get_lang() + '">' + data.Balance.Label_TotalCredit + '</a>';

                output +=  ' &nbsp&nbsp <span id="side-help" style="display:none;"><br>' + data.Balance.Side_Help + '</span>';
                output +=  ' &nbsp&nbsp <a href ="#" onclick="$(\'#side-help\').toggle();"><span class="glyphicon glyphicon-question-sign"></span></a>';
            }

            output += ':</span>';

            output += '<table id="balance" id=balance BORDER=0 cellpadding=15 cellspacing=0 width="800" ' +
                ' class="tiny table table-striped" style="border: 1px solid #ddd; word-wrap: break-word;" >';
            output += '<tr bgcolor="f1f1f1"><td><b>' + data.Balance.Label_asset_key +
                '<td><b>' + data.Balance.Label_asset_name + '<td><b>' + data.Balance.Label_Balance_1 +
                '<td><b>' + data.Balance.Label_Balance_2 + '<td><b>' + data.Balance.Label_Balance_3 + '<td><b>'
                 + data.Balance.Label_Balance_4 + '<td><b>' + data.Balance.Label_Balance_5 + '</tr>';
            for (key in data.Balance.balances) {
                output += '<tr><td><a href ="?asset=' + data.Balance.balances[key].asset_key +
                    get_lang() + '">' + data.Balance.balances[key].asset_key + '</a>';
                output += '<td><a href="?asset=' + data.Balance.balances[key].asset_key +
                    get_lang() + '">' + data.Balance.balances[key].asset_name + '</a>';
                if (data.hasOwnProperty('person')) {
                output += '<td><a href ="?person=' + data.person_key + '&asset=' + data.Balance.balances[key].asset_key +
                    '&position=1' + get_lang() + '">' + data.Balance.balances[key].balance_1 + '</a>';
                output += '<td><a href ="?person=' + data.person_key + '&asset=' + data.Balance.balances[key].asset_key +
                    '&position=2' + get_lang() + '">' + data.Balance.balances[key].balance_2 + '</a>';
                output += '<td><a href ="?person=' + data.person_key + '&asset=' + data.Balance.balances[key].asset_key +
                    '&position=3' + get_lang() + '">' + data.Balance.balances[key].balance_3 + '</a>';
                output += '<td><a href ="?person=' + data.person_key + '&asset=' + data.Balance.balances[key].asset_key +
                    '&position=4' + get_lang() + '">' + data.Balance.balances[key].balance_4 + '</a>';
                output += '<td><a href ="?person=' + data.person_key + '&asset=' + data.Balance.balances[key].asset_key +
                    '&position=4' + get_lang() + '">' + data.Balance.balances[key].balance_5 + '</a>';
                } else {
                output += '<td>' + data.Balance.balances[key].balance_1 + '<td>' +
                    data.Balance.balances[key].balance_2 + '<td>' + data.Balance.balances[key].balance_3
                    + '<td>' + data.Balance.balances[key].balance_4 + '<td>' + data.Balance.balances[key].balance_5;
                }

            }
            output += '</table><br><br>';
            output += transactions_Table(data);

            return output;
        }



        function polls11(a) {
            window.location = "/index/blockexplorer.html?polls&asset=" + a.value + get_lang();


        }

        function oppa() {
            var output = '';
            output += '<select name="SelectMyLove" id = "aa" onChange="polls11(this)"; >';
            output += ' <option value="1" selected>1</option>';
            output += ' <option value="6">6</option> </select>';

            return output;
        }

        function Onselect(data, a) {

            for (c in data.assets) {
                if (a == data.assets[c].name) {
                    document.location = '?poll=' + encodeURIComponent(key) + '&asset=' + c;
                }
            }
        }

        function poll_old(data) {

            var output = "";

            output += lastBlock(data.lastBlock);

            if (data.hasOwnProperty('error')) {
                output += '<br><h5>' + data.error + '</h5>';

                return output;
            }

            output += '<table width="" border=0><tr><td align=left><br>';

            output += '<font size=+1><b>Poll:</b> <a href=?poll=' + encodeURIComponent(data.pool.name) + get_lang() + '>' + escapeHtml(data.pool.name) + '</a></font><br><br>';

            output += '<b>Description:</b><br>' + fformat(data.pool.description) + '<br><br>';

            output += '<b>Creator:</b> <a href=?address=' + data.pool.creator + get_lang() + '>' + data.pool.creator + '</a><br><br>';

            output += '<table border="0" cellspacing="5" class="tiny table">';
            output += '<tr><td><b>Option</b></td><td><b>Votes</b></td><td width="390"><b>% of total</b></td></tr>';

            for (key in data.pool.options) {
                output += '<tr>';
                output += '<td>' + escapeHtml(key);
                output += '<td>' + addCommas(data.pool.options[key]);

                if (data.pool.totalVotes != '0.00000000') {
                    procent = data.pool.options[key] / data.pool.totalVotes;
                    procentRound = (procent * 100).toFixed(2);
                    width = Math.round(procent * 300);
                } else {
                    procentRound = '0';
                    width = 0;
                }

                output += '<td><img src=img/bar_left.gif border=0 height=11 width=2><img src=img/bar.gif border=0 height=11 width=' + width + '><img src=img/bar_right.gif border=0 height=11 width=2> [' + procentRound + '%]';
            }

            //output += '<tr><td colspan="3"></td></tr>';
            output += '<tr><td><b>All Votes:</b></td><td align="left" colspan="2">';
            output += addCommas(data.pool.totalVotes);
            output += '</td></tr></tbody></table>';

            output += '<br>';

            output += '<table border="0" cellspacing="5" class="tiny table table-condensed">';
            output += '<tr><td><b>Address</b></td><td><b>Option</b></td><td><b>Votes</b></td></tr>';

            for (key in data.pool.votes) {
                output += '<tr>';
                output += '<td>' + '<a href=?address=' + key + get_lang() + '>' + key + '</a>';
                output += '<td>' + escapeHtml(data.pool.votes[key].option);
                output += '<td>' + addCommas(data.pool.votes[key].votes);
            }
            output += '</table>';


            return output;
        }



        function isFilter(param) {

            return filters.hasOwnProperty(param);
        }

        function delPrm(Url, Prm) {
            var a = Url.split('?');
            var re = new RegExp('(\\?|&)' + Prm + '=[^&]+', 'g');
            Url = ('?' + a[1]).replace(re, '');
            Url = Url.replace(/^&|\?/, '');
            var dlm = (Url == '') ? '' : '?';
            return a[0] + dlm + Url;
        };

        function genFilterUrlForAll() {
            elementShowOnly = document.getElementsByClassName('showOnly');

            urlBuf = location.href.replace(location.hash, '');
            urlBuf = delPrm(urlBuf, 'showWithout');
            urlBuf = delPrm(urlBuf, 'showOnly');

            for (var i = 0; i < elementShowOnly.length; i++) {
                elementShowOnly[i].href = urlBuf + '&showOnly=' + elementShowOnly[i].id;
            }


            elementTypes = document.getElementsByName('types');

            if (params.hasOwnProperty('showOnly')) {
                showOnlyArray = params['showOnly'].split(',');

                for (var i = 0; i < elementTypes.length; i++) {
                    for (var k = 0; k < showOnlyArray.length; k++) {
                        elementTypes[i].checked = false;
                        if (elementTypes[i].value == showOnlyArray[k]) {
                            elementTypes[i].checked = true;
                        }
                    }
                }
            } else if (params.hasOwnProperty('showWithout')) {
                showWithoutArray = params['showWithout'].split(',');

                for (var i = 0; i < elementTypes.length; i++) {
                    elementTypes[i].checked = true;
                    for (var k = 0; k < showWithoutArray.length; k++) {
                        if (elementTypes[i].value == showWithoutArray[k]) {
                            elementTypes[i].checked = false;
                        }
                    }
                }

            }
        }

        function genFilterUrl() {

            if (document.getElementById("showWithout") === null) {
                return 0;
            }

            elementTypes = document.getElementsByName('types');

            var typesArray = [];

            for (var i = 0; i < elementTypes.length; i++) {
                if (!elementTypes[i].checked) {
                    typesArray.push(elementTypes[i].value);
                }
            }

            urlBuf = location.href.replace(location.hash, '');
            urlBuf = delPrm(urlBuf, 'showWithout');
            urlBuf = delPrm(urlBuf, 'showOnly');

            document.getElementById("showWithout").href = urlBuf;

            if (typesArray.length > 0) {
                document.getElementById("showWithout").href += '&showWithout=' + typesArray.join(',');
            }

            document.getElementById("cancelFilter").href = urlBuf;
        }

        function mainQuery(data) {
            var output = '';

            if (data.hasOwnProperty('error')) {
                output += '<h2>' + data.error + '</h2>';
                output += '<h4>for Help use blockexplorer.json</h4>';
                return output;
            }

            var transactionTypes = ["", "Genesis", "Payment", "Name Registration", "Name Update", "Name Sale", "Cancel Name Sale", "Name Purchase", "Poll Creation", "Poll Vote", "Arbitrary Transaction", "Asset Issue", "Asset Transfer", "Order Creation", "Cancel Order", "Multi Payment", "Deploy AT", "Message",
                "", ""];
            transactionTypes[31] = "Send Record";
            transactionTypes[21] = "Issue Asset Record";
            transactionTypes[41] = "Hashes Record";

            output += lastBlock(data.lastBlock);

            //try {

            if (data.type == 'address' || data.type == 'at') {
                if (data.withoutBlocks) {
                    withoutBlocks = '&withoutBlocks';
                } else {
                    withoutBlocks = '';
                }

                if (data.showOnly) {
                    showOnly = '&showOnly=' + data.showOnly;
                } else {
                    showOnly = '';
                }

                if (data.showWithout) {
                    showWithout = '&showWithout=' + data.showWithout;
                } else {
                    showWithout = '';
                }

                if (data.allOnOnePage) {
                    allOnOnePage = '&allOnOnePage';
                } else {
                    allOnOnePage = '';
                }

                urlstart = '?address=' + data.address + '&start=' + data.start + withoutBlocks + allOnOnePage + showOnly + showWithout;
                url = '?address=' + data.address + withoutBlocks + allOnOnePage + showOnly + showWithout;
            }

            if (data.type == 'address') {
                return output + address(data);
            } else
            if (data.type == 'block') {
                return output + block(data);
            } else
            if (data.type == 'person') {
                if (data.allOnOnePage) {
                    allOnOnePage = '&allOnOnePage';
                } else {
                    allOnOnePage = '';
                }

                urlstart = '?person=' + data.name + '&start=' + data.start + allOnOnePage;
                url = '?person=' + data.name + allOnOnePage;

                output += '<table width="1280" border=0><tr><td align=left>';
                output += '<font size="+1">Person: <a href=?name=' + encodeURIComponent(data.name) + get_lang() + '>' + escapeHtml(data.name) + '</a></font>';

                output += '<br><br>';
            } else
            if (data.type == 'statement') {
                output += statement(data);
            } else
            if (data.type == 'name') {
                if (data.allOnOnePage) {
                    allOnOnePage = '&allOnOnePage';
                } else {
                    allOnOnePage = '';
                }

                urlstart = '?name=' + data.name + '&start=' + data.start + allOnOnePage;
                url = '?name=' + data.name + allOnOnePage;

                output += '<table width="1280" border=0><tr><td align=left>';
                output += '<font size="+1">Name: <a href=?name=' + encodeURIComponent(data.name) + get_lang() + '>' + escapeHtml(data.name) + '</a></font>';

                output += '<br><br>';
            }

            else if (data.type == 'tx') {

                return tx(data);
            }

            else if (data.type == 'unconfirmed') {
                url = '?unconfirmed';
                urlstart = url;
                output += '<table width="1280" border=0><tr><td align=left>';
                output += '<font size="+1">Unconfirmed Transactions</font><br><br>';
                output += 'Transactions count: ' + data.start + '<br>';

            }

            if (data.type == 'atTransaction') {
                url = '?atTx=' + data.atTransaction;
                urlstart = url;
                output += '<table width="1280" border=0><tr><td align=left>';
                output += '<font size="+1">Automated Transaction</font><br>';
            }


            if (data.type == 'at') {
                output += '<table width="1280" border=0><tr><td align=left>';
                output += '<br><font size="+1">AT Account: <a href=?address=' + data.address + get_lang() + '>' + data.address + '</a></font>';

                output += '<table width="100%" border=0><tr><td valign=top align=left rowspan=2>';
                output += '<br><b>Creator:</b> <a href=?address=' + data.at.creator + get_lang() + '>' + data.at.creator + '</a>';
                output += '<br><br><b>AT Type:</b> ' + data.at.type;
                output += '<br><br><b>Description:</b> ' + fformat(data.at.description);
                output += '<br><br><b>Tags:</b> ' + fformat(data.at.tags);
                output += '<br><br><b>Min Activation Amount:</b> ' + data.at.minActivation + ' ERA';
                output += '<br><br><b>Dead:</b> ' + data.at.state.dead;
                output += '<br><br><b>Frozen:</b> ' + data.at.state.frozen;

                output += '<td><br><b>Code:</b><pre>';
                if (data.at.state.machineCode != '') {
                    output += wordwrap(data.at.state.machineCode, 100, '<br>', true);
                } else {
                    output += '<b>No</b>';
                }
                output += '<tr>';
                output += '<td><b>Data:</b><pre>';
                if (data.at.state.machineData != '') {
                    output += wordwrap(data.at.state.machineData, 100, '<br>', true);
                } else {
                    output += '<b>No</b>';
                }
                output += '</table>';
                output += '<br><br><font size="+1"><b>Balance:</b> ' + addCommas(data.at.accountBalance) + ' ERA</font>';
                output += '<br><br>';
            }

            if (data.type == 'trade') {
                url = '?trade=' + data.trade;
                urlstart = url;
                output += '<table width="1280" border=0><tr><td align=left>';
                output += '<font size="+1">Trade</font><br>';
            }

            //if(data.type == 'address' || data.type == 'at')
            if (data.type == 'at') {
                output += pages(data.pages, data.start, data.end, url, data.allOnOnePage);
            }

            if (data.type == 'name') {
                output += pagesOld(data.countTx.allCount, data.txOnPage, data.start, data.end, url, data.allOnOnePage);
            }

            output += '<br>';

            {
                for (var i = data.start; i >= data.end; i--) {
                    if (!data.hasOwnProperty(i)) {
                        continue;
                    }

                    output += '<a class="anchor" id=' + i + ' name=' + i + '></a>';

                    if (data[i].type == 'block') // block
                    {

                        output += '<table width=100%><tr><td>';

                        output += '<table width="100%" style="border-top: 1px solid #ddd; background-color: #f1f1f1; border-spacing: 7px; border-collapse: separate;">';

                        if (data.type == 'block') {
                            output += '<tr><td><a class=without href=' + urlstart + get_lang() + '>##</a>&nbsp;&nbsp;';
                        } else {
                            output += '<tr><td><a class=without href=' + urlstart + '#' + i + get_lang() + '>#' + i + '</a>&nbsp;&nbsp;';
                        }

                        output += '<a href=?block=' + data[i].block.signature + get_lang() + '>' + data[i].block.signature.substr(0, 80) + '...' + '</a></td>';

                        output += '<td align=right width=250>Height: <a href=?block=' + data[i].block.height + get_lang() + '>' + data[i].block.height + '</a>';
                        output += ' / confirmations: ' + data[i].block.confirmations + '</td>';

                        output += '<td align=right width=200>' + convertTimestamp(data.pageItems[i].timestamp, true) + '</td></tr></table>';

                        output += '<tr><td>';
                        output += '<table width="100%" class="tiny table table-striped"><tr><td width="70" align="center">';
                        output += '<b>Action</b></td><td width="290"><b>Generator</b></td><td><b>Fee</b></td>';
                        if (data[i].hasOwnProperty('balance')) {
                            output += '<td width=180><b>Balance</b></td>';
                        }
                        output += '</tr>';
                        output += '<tr><td align="center"><img src="img/00_generating.png"><br><font size="-2">Generating</font></td>';
                        if (data[i].type == 'block') {
                            output += '<td><a href=?address=' + data[i].block.generator + get_lang() + '>' + data[i].block.generator + '</a>';
                        } else {
                            output += '<td><font color="dimgray">' + data[i].block.generator + '</font></td>';
                        }
                        output += '<td>' + addCommas(data[i].block.fee) + ' <font size="-2">COMPU</font>' + '</td>';

                        if (data[i].hasOwnProperty('balance')) {
                            output += '<td>' + printBalance(data[i].balance) + '</td>';
                        }

                        output += '</tr></table>';

                        output += '</table>';
                    }

                    if (data[i].type == 'trade') // Trade
                    {
                        output += '<table width="100%"><tr><td>';

                        output += '<table width="100%" style="border-top: 1px solid #ddd; background-color: #f1f1f1; border-spacing: 7px; border-collapse: separate;">';

                        output += '<tr><td><a class=without href=' + urlstart + '#' + i + get_lang() + '>#' + i + '</a>&nbsp;&nbsp;';
                        output += '<a href=?trade=' + data[i].trade.initiatorTxSeqNo + '/' + data[i].trade.targetTxSeqNo + get_lang() + '>';
                        output += data[i].trade.label_Trade + ' #' + data[i].trade.initiatorTxSeqNo + '/' + data[i].trade.targetTxSeqNo + '</a></td>';

                        output += '<td><a href=?order=' + data[i].trade.initiatorTxSeqNo + get_lang() + '>';
                        output += data[i].trade.label_Taking_Order + ' #' + data[i].trade.initiatorTxSeqNo + '</a> ';
                        output += '<td><a href=?order=' + data[i].trade.targetTxSeqNo + get_lang() + '>';
                        output += data[i].trade.label_Order + ' #' + data[i].trade.targetTxSeqNo + '</a></td>';

                        output += '<td align=right width=250>Height: <a href=?block=' + data[i].trade.height + get_lang() + '>' + data[i].trade.height + '</a>';
                        output += ' / confirmations: ' + data[i].trade.confirmations + '</td>';

                        output += '<tr><td colspan=4>';
                        output += '<table width="100%" class="tiny table table-striped"><tr><td width="70" align="center">';

                        output += '<b>Action</b></td><td width="290"><b>Seller</b></td><td width="290"><b>Buyer</b></td>';
                        output += '<td width=135><b>Have</b></td><td width=135><b>Want</b></td><td width=135><b>Price</b></td>';

                        if (data[i].hasOwnProperty('balance')) {
                            output += '<td width=180><b>Balance</b></td>';
                        }
                        output += '</tr>';

                        output += '<tr><td align="center">';

                        output += '<img src=img/asset_trade.png>';

                        output += '<br><font size="-2">Asset Trade</font></td>';

                        var img1 = '';
                        var img2 = '';

                        if (data[i].trade.targetCreator == data.address) {
                            output += '<td><font color="dimgray">' + data[i].trade.targetCreator + '</font>';
                            img1 = 'img/redright.png';
                        } else {
                            output += '<td><a href=?address=' + data[i].trade.targetCreator + get_lang() + '>' + data[i].trade.targetCreatorName + '</a>';
                            img1 = 'img/grright.png';
                        }

                        if (data[i].trade.targetCreator == data[i].trade.initiatorCreator) {
                            img1 = 'img/grright.png';
                        }

                        output += '<p>';

                        output += addCommas(data[i].trade.amountWant) + ' ' + getItemNameMini('asset', data[i].trade.wantKey, data[i].trade.wantName);

                        output += ' <img src=' + img1 + ' style="vertical-align: middle;">';

                        output += '</p>';

                        output += '</td>';

                        if (data[i].trade.initiatorCreator == data.address) {
                            output += '<td><font color="dimgray">' + data[i].trade.initiatorCreator + '</font><br>';
                            img2 = 'img/redleft.png';
                        } else {
                            output += '<td><a href=?address=' + data[i].trade.initiatorCreator + get_lang() + '>' + data[i].trade.initiatorCreatorName + '</a>';
                            img2 = 'img/grleft.png';
                        }

                        if (data[i].trade.targetCreator == data[i].trade.initiatorCreator) {
                            img2 = 'img/grleft.png';
                        }

                        output += '<p>';
                        output += '<img src=' + img2 + ' style="vertical-align: middle;"> ';

                        output += '' + addCommas(data[i].trade.amountHave) + ' ' + getItemNameMini('asset', data[i].trade.haveKey, data[i].trade.haveName);

                        output += '</p>';
                        output += '</td>';

                        output += '<td>' + ' <a href=?asset=' + data[i].trade.wantKey + get_lang() + '>' + getItemName(1000, data[i].trade.wantKey, data[i].trade.wantName) + '</a>';

                        output += '<td>' + ' <a href=?asset=' + data[i].trade.haveKey + get_lang() + '>' + getItemName(1000, data[i].trade.haveKey, data[i].trade.haveName) + '</a>';

                        output += '<td>' + addCommas(data[i].trade.reversePrice);

                        if (data[i].hasOwnProperty('balance')) {
                            output += '<td>' + printBalance(data[i].balance) + '</td>';
                        }

                        output += '</tr></table>';

                        output += '</table>';
                    }

                    if (data[i].type == 'atTransaction') // Automated Transaction
                    {
                        output += '<table width="100%"><tr><td>';

                        output += '<table width="100%" style="border-top: 1px solid #ddd; background-color: #f1f1f1; border-spacing: 7px; border-collapse: separate;">';

                        output += '<tr><td><a class=without href=' + urlstart + '#' + i + get_lang() + '>#' + i + '</a> ';

                        output += '<a href=?atTx=' + data[i].atTransaction.blockHeight + ':' + data[i].atTransaction.seqNo + get_lang() + '>';
                        output += data[i].atTransaction.blockHeight + ':' + data[i].atTransaction.seqNo + '</a></td>';
                        output += '<td align=right width=250>';
                        if (data.type != 'block') {
                            output += 'Height: <a href=?block=' + data[i].atTransaction.blockHeight + get_lang() + '>' + data[i].atTransaction.blockHeight + '</a>';
                            output += ' / confirmations: ' + data[i].atTransaction.confirmations;
                        }
                        output += '</td>';
                        output += '<td align=right width=200>' + convertTimestamp(data[i].atTransaction.timestamp, true) + '</td></tr></table>';

                        output += '<tr><td>';

                        output += '<table width="100%" class="tiny table table-striped"><tr><td width="70" align="center">';

                        output += '<b>Action</b></td><td width="290"><b>Sender</b></td><td width=200><b>Amount</b></td>';
                        output += '<td><b>Recipient</b></td><td><b>SeqNo</b></td>';
                        if (data[i].hasOwnProperty('balance')) {
                            output += '<td width=180><b>Balance</b></td>';
                        }
                        output += '</tr>';
                        output += '<tr><td align="center" rowspan=2>';

                        if (data[i].attransaction.creator == data.address) {
                            output += '<img src=img/at_tx_out.png>';
                        } else {
                            output += '<img src=img/at_tx_in.png>';
                        }
                        output += '<br><font size="-2">Automated Transaction</font></td>';

                        if (data[i].attransaction.creator == data.address) {
                            output += '<td rowspan=2><font color="dimgray">' + data[i].attransaction.creator + '</font></td>';
                        } else {
                            output += '<td rowspan=2><a href=?address=' + data[i].attransaction.creator + get_lang() + '>' + data[i].attransaction.creator + '</a></td>';
                        }
                        output += '<td>' + addCommas(data[i].atTransaction.amount) + ' <font size="-2">ERA</font>';

                        if (data[i].atTransaction.recipient == data.address) {
                            output += '<td><font color="dimgray">' + data[i].atTransaction.recipient + '</font></td>';
                        } else {
                            if (data[i].atTransaction.recipient == '11111111111111111111111111') {
                                output += '<td>11111111111111111111111111<br>';
                                output += '(generator of <a href=?block=' + data[i].atTransaction.blockHeight + get_lang() + '>' + data[i].atTransaction.blockHeight + '</a> block: ';
                                output += '<a href=?address=' + data[i].atTransaction.generatorAddress + get_lang() + '>' + data[i].atTransaction.generatorAddress + '</a>)';
                            } else {
                                output += '<td><a href=?address=' + data[i].atTransaction.recipient + get_lang() + '>' + data[i].atTransaction.recipient + '</font></td>';
                            }
                        }

                        output += '<td>' + data[i].atTransaction.seqNo;

                        if (data[i].hasOwnProperty('balance')) {
                            output += '<td rowspan=2>' + printBalance(data[i].balance) + '</td>';
                        }
                        output += '</tr>';

                        var message = data[i].atTransaction.message;
                        if (message == '') {
                            message = '<b>no</b>';
                        }
                        output += '<tr><td colspan=3><b>Message:</b> ' + fformat(message); //wordwrap(message, 80, '<br>', true);

                        output += '</table>';

                        output += '</table>';
                    }

                    ////// TRANSACTIONS ////////
                    if (data[i].type == 'tx') {
                        output += transactionLite('?tx', data, i, data[i]);
                    }
                }

                //	if(data.type == 'address' || data.type == 'at')
                if (data.type == 'at') {
                    output += pages(data.pages, data.start, data.end, url, data.allOnOnePage);
                }

                if (data.type == 'name') {
                    output += pagesOld(data.countTx.allCount, data.txOnPage, data.start, data.end, url, data.allOnOnePage);
                }

                output += '</table>';
            }

            //} catch(e) {
            //	output += "<h1>ERROR<br>"+e+"</h1>";
            //}

            return output;
        }

        function block(data) {

            var output = '';
            url = '?block=' + data.blockHeight;
            urlstart = url;

            output += '<table width="1280" border=0><tr><td align=left>';
            output += '<font size="+2">' + data.Label_block + ': ';
            if (data.hasOwnProperty('parentBlockSignature')) {
                output += '<a class="button ll-blue-bgc" href="?block=' + (data.blockHeight - 1) + get_lang() + '"><b><span class="glyphicon glyphicon-triangle-left"></span></b></a> ';
            }
            output += '<a href="?block=' + data.blockHeight + get_lang() + '">' + data.blockHeight + '</a> ';
            if (data.hasOwnProperty('childBlockSignature')) {
                output += '<a class="button ll-blue-bgc" href="?block=' + (data.blockHeight + 1) + get_lang() + '"><b><span class="glyphicon glyphicon-triangle-right"></span></b></a> ';
            }
            output += '</font>';
            output += '<br><br>';

            output += data.Label_Block_version + ': <b>' + data.version + '</b><br>';

            output += data.Label_Forger + ': <a href=?address=' + data.blockCreator + get_lang() + '><b>' + data.blockCreatorPerson + '</b></a><br>';

            if (data.countTx.hasOwnProperty('txsCount')) {
                output += data.Label_Transactions_count + ': <b>' + data.countTx.txsCount + '</b><br>';
            }

            output += data.Label_Size + ': <b>' + data.size + '</b><br>';
            output += data.Label_Total_Fee + ': <b>' + data.totalFee + '</b><br>';
            output += '<br>';

            output += data.Label_Generating_Balance + ': <b>' + addCommas(data.generatingBalance) + '</b><br>';
            output += data.Label_Win_Value + ': <b>' + addCommas(data.winValue) + '</b><br>';
            output += data.Label_Target + ': <b>' + addCommas(data.target) + '</b><br>';
            output += data.Label_Targeted_Win_Value + ': <b>' + addCommas(data.winValueTargeted) + '</b><br>';
            output += '<br>';

            if (data.hasOwnProperty('parentBlockSignature')) {

                output += data.Label_Parent_block + ': ' + (data.blockHeight - 1) + ',   ' + data.Label_Signature + ': ';
                output += '<a  href=?block=' + data.parentBlockSignature + get_lang() + '>' + data.parentBlockSignature + '</a>';
                output += '<br><br>';
            }

            output += '<b>' + data.Label_Current_block + ': ' + (data.blockHeight) + ',    ' + data.Label_Signature + ':</b> ';
            output += '<a  href=?block=' + data.blockSignature + get_lang() + '>' + data.blockSignature + '</a>';
            output += '<br><br>';

            if (data.hasOwnProperty('childBlockSignature')) {
                output += data.Label_Child_block + ': ' + (data.blockHeight + 1) + ',   ' + data.Label_Signature + ': ';
                output += '<a  href=?block=' + data.childBlockSignature + get_lang() + '>' + data.childBlockSignature + '</a>';
                output += '<br><br>';
            }
            output += transactions_Table(data);
            return output;
        }

        function uintToString(uintArray) {
            var encodedString = String.fromCharCode.apply(null, uintArray);
            try {
                return decodeURIComponent(escape(encodedString));
            } catch (e) {
                return encodedString;
            }
        }

        function htmlFilter(str) {
            if (str == null) return "";
            return str
                .replace(/</g, "&lt;")
                .replace(/>/g, "&gt;")
                .replace(/\n/g, "<br>");
        }

        function pages(datapages, datastart, dataend, url, dataallOnOnePage) {
            var pages = '';

            if (datapages.length == 0) {
                return pages;
            }

            pages += '<table width="100%"><tr><td>Pages: ';

            /*	if(datastart <  parseInt(datapages[0].replace( 'start_', '')))
	{
		var start;
		for (var i = datapages.length/2-1; i >= 0 ; i--)
		{
			start = parseInt(datapages[i*2].replace( 'start_', ''));
			if(start > datastart)
			{
				break;
			}
		}
		pages += '<a class=without style="font-size: 15px;" href=' + url + '&start=' + start + get_lang()+'>«</a> ';
	}
*/
            for (var i = 0; i < datapages.length / 2; i++) {
                start = parseInt(datapages[i * 2].replace('start_', ''));
                end = parseInt(datapages[i * 2 + 1].replace('end_', ''));

                if (datastart == start && dataend == end && !allOnOnePage) {
                    pages += '<b><nobr>[' + start + '-' + end + ']</nobr></b> ';
                } else {
                    buf = "";
                    if ((datastart >= end) && (dataend <= start)) {
                        buf = " style='font-weight: bold;'";
                    }

                    pages += '<nobr><a class=without' + buf + ' href=' + url.replace('&allOnOnePage', '') + '&start=' + start + get_lang() + '>' + start + '-' + end + '</a></nobr> ';
                }
            }

            /* if(dataend >  parseInt(datapages[datapages.length-1].replace( 'end_', '')))
	{
		var start;
		for (var i = 0; i < datapages.length/2; i++)
		{
			start = parseInt(datapages[i*2].replace( 'start_', ''));
			if(start < datastart)
			{
				break;
			}
		}
		pages += '<a class=without style="font-size: 15px;" href=' + url + '&start=' + start +get_lang()+ '>»</a> ';
	}
*/
            if (allOnOnePage) {
                pages += '&nbsp;<b><nobr>[All on one page]</nobr></b>';
            } else {
                pages += '&nbsp;<a class=without href=' + url.replace('&allOnOnePage', '') + '&allOnOnePage' + get_lang() + '>All on one page</a>';
            }

            pages += '</table>';

            return pages;
        }

        function pagesOld(dataallCount, datatxOnPage, datastart, dataend, url, allOnOnePage) {
            var pages = '';
            var start = 0;
            var end = 0;
            var k = 0;
            pages += '<table width="100%"><tr><td>Pages: ';

            if (datastart < dataallCount) {
                pages += '<a class=without style="font-size: 15px;" href=' + url + '&start=' + (datastart + datatxOnPage + 1) + get_lang() + '>«</a> ';
            }

            do {
                k++;
                if (k == 1) {
                    start = dataallCount;
                } else {
                    start = end - 1;
                }

                if (start > datatxOnPage) {
                    end = start - datatxOnPage;
                } else {
                    end = 1;
                }

                if (datastart <= start && datastart >= end && !allOnOnePage) {
                    pages += '<b><nobr>[' + start + '-' + end + ']</nobr></b> ';
                } else {
                    pages += '<nobr><a class=without href=' + url.replace('&allOnOnePage', '') + '&start=' + start + get_lang() + '>' + start + '-' + end + '</a></nobr> ';
                }
            } while (end > 1)

            if (dataend > 1) {
                pages += ' <a class=without style="font-size: 15px;" href=' + url + '&start=' + (dataend - 1) + get_lang() + '>»</a>';
            }

            if (allOnOnePage) {
                pages += '&nbsp;<b><nobr>[All on one page]</nobr></b>';
            } else {
                pages += '&nbsp;<a class=without href=' + url.replace('&allOnOnePage', '') + '&allOnOnePage' + get_lang() + '>All on one page</a>';
            }

            pages += '</table>';

            return pages;
        }

        function printBalance(balance) {
            var output = '';
            for (key in balance) {
                output += '' + addCommas(balance[key].amount) + ' ' + getItemNameMini('asset', key, balance[key].assetName) + '<br>';
            }
            return output;
        }

        function search(data) {
            var output = "";

            if (data.hasOwnProperty('error')) {
                return '<h2>' + data.error + '</h2>';
            }

            var foundList = "";
            var foundOne = "";

            for (key in data.foundList) {
                var row = data.foundList[key];
                switch (row[1]) {
                    case 'address':
                        foundList += '<li><a href="?address=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?address=' + encodeURIComponent(data.query);
                        break
                    case 'atAccount':
                        foundList += '<li><a href="?address=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?address=' + encodeURIComponent(data.query);
                        break
                    case 'transactionSignature':
                        foundList += '<li><a href="?tx=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?tx=' + encodeURIComponent(data.query);
                        break
                    case 'blockSignature':
                    case 'blockHeight':
                    case 'blockLast':
                        foundList += '<li><a href="?block=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?block=' + encodeURIComponent(data.query);
                        break
                    case 'name':
                        foundList += '<li><a href="?name=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?name=' + encodeURIComponent(data.query);
                        break
                    case 'assets':
                        foundList += '<li><a href="?asset=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?asset=' + encodeURIComponent(data.query);
                        break
                    case 'pool':
                        foundList += '<li><a href="?pool=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?pool=' + encodeURIComponent(data.query);
                        break
                    case 'trade':
                        foundList += '<li><a href="?trade=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?trade=' + encodeURIComponent(data.query);
                        break
                    case 'atTx':
                        foundList += '<li><a href="?atTx=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?atTx=' + encodeURIComponent(data.query);
                        break
                    case 'statement':
                        var params = data.query.split('-');
                        foundList += '<li><a href="?statement=' + params[0] + '&seqNo=' + params[1] + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?statement=' + params[0] + '&seqNo=' + params[1];
                        break
                    case 'person':
                        foundList += '<li><a href="?person=' + encodeURIComponent(data.query) + get_lang() + '">' + row[2] + ': ' + htmlFilter(data.query) + '</a></li>';
                        foundOne = '?person=' + encodeURIComponent(data.query);
                        break
                }
            }

            if (data.foundCount == 1) {
                document.location.href = foundOne + get_lang();
                return null;
            }

            output += lastBlock(data.lastBlock);

            if (data.foundCount == 0) {
                output += "<h2>" + data["title"] + "</h2>";
            } else {
                output += '<table width="" border=0><tr><td align=left>';
                output += "<h2>" + data["title"] + ":</h2>";
                output += "<ul>";
                output += foundList;
                output += "</ul>";

            }

            return output;
        }

        function lastBlock(lastBlock) {
            if (lastBlock === undefined)
                return "";

            var output = '';
            output += lastBlock.Label_Last_processed_block + ': <a href=?block=' + lastBlock.height + get_lang() + '>' + lastBlock.height + '</a>';
            output += ' (' + convertTimestamp(lastBlock.timestamp, true) + ', ' + secToFine(new Date().getTime() - lastBlock.timestamp, lastBlock) + '  ' + lastBlock.Label_ago + ') ';
            output += '<br>';

            return output;
        }

        function parseUrlQuery() {
            var data = {};
            if (document.location.search) {
                var pair = (location.search.substr(1)).split('&');
                for (var i = 0; i < pair.length; i++) {
                    var param = pair[i].split('=');
                    if (param.length > 1) {
                        data[param[0]] = param[1];
                    } else {
                        data[param[0]] = true;
                    }
                }
            }
            return data;
        }

        function blocks(data) {

            var output = '';
            if (data.hasOwnProperty('error')) {
                return '<h2>' + data.error + '</h2>';
            }
            var notDisplayPages = data.notDisplayPages;
            var numberShiftDelta = data.pageSize;
            //Отображение последнего блока
            output += lastBlock(data.lastBlock);
            var start = data.start;
            //Отображение компонента страниц(вверху)
            //output += pagesComponentBeauty(start, data.Label_Persons, data.lastNumber, data.pageSize, 'start');
            output += pagesComponent2(data);

            //Отображение шапки таблицы
            output += '<table id=blocks BORDER=0 cellpadding=15 cellspacing=0 width="">';
            output += '<tr><td align=left>';
            output += '<table id=blocks_Transactions BORDER=0 cellpadding=15 cellspacing=0 width="1180" >' +
                '<tr><td><a href=?unconfirmed' + get_lang() + '>' + data.Label_Unconfirmed_transactions
                + ': ' + data.unconfirmedTxs + '</a>';
            output += '<td align="right">' + data.Label_total_transactions + ': ' + data.totaltransactions + "</table>";
            output += '<table id=blocks BORDER=0 cellpadding=15 cellspacing=0 width="1180"  ' +
                'class="tiny table table-striped" style="border: 1px solid #ddd;">';
            output += '<tr>' +
                '<td><b>' + data.Label_Height +
                '<td><b>' + data.Label_Time +
                '<td><b>' + data.Label_Generator +
                '<td><b>' + data.Label_Gen_balance +
                '<td><b>' + data.Label_Delta_Height +
                '<td><b>' + data.Label_WV +
                '<td><b>' + data.Label_Target +
                '<td><b>' + data.Label_dtWV +
                '<td><b>' + data.Label_TXs +
                '<td><b>' + data.Label_Fee;

            var dtWV;
            var abs;
            //Отображение таблицы элементов блоков
            //var length = Object.keys(data.pageItems).length;
            //for (var i = 0; i < length - 1; i++) {
            for (var i in data.pageItems) {
                dtWV = data.pageItems[i].winValueTargeted - 100.0;
                abs = Math.abs(dtWV);
                if (abs < 1) {
                    dtWV = dtWV.toFixed(3);
                } else if (abs > 100) {
                    dtWV = dtWV.toFixed(0);
                } else {
                    dtWV = dtWV.toPrecision(3);
                }

                output += '<tr>' +
                    '<td><a href=?block=' + data.pageItems[i].height + get_lang() + '>' + data.pageItems[i].height + '</a>' +
                    '<td>' + convertTimestamp(data.pageItems[i].timestamp, true) +
                    '<td>' + '<a href=?address=' + data.pageItems[i].generator + get_lang() + '>' + data.pageItems[i].generator +
                    '<td>' + addCommas(data.pageItems[i].generatingBalance) +
                    '<td>' + data.pageItems[i].deltaHeight +
                    '<td>' + addCommas(data.pageItems[i].winValue) +
                    '<td>' + addCommas(data.pageItems[i].target) +
                    '<td>' + dtWV + '%' +
                    '<td>' + data.pageItems[i].transactionsCount +
                    '<td>' + addCommas(data.pageItems[i].totalFee);
            }

            //Отображение ссылки предыдущая
            output += '</table></td></tr></table>';
            //Отображение компонента страниц(снизу)
            //output += pagesComponentBeauty(start, data.Label_Blocks, data.lastNumber, data.pageSize, 'start');
            output += pagesComponent2(data);

            return output;
        }

        function transactions(data) {

            return lastBlock(data.lastBlock) + transactions_Table(data);
        }

        function get_lang() {

// получаем индекс выбранного элемента
            var selind = document.getElementById("Langs").options.selectedIndex;
            var txt = document.getElementById("Langs").options[selind].text;
            var val = document.getElementById("Langs").options[selind].value;

            return '&lang=' + document.getElementById("Langs").options[selind].value;
        }

        function getQueryParams(name) {
            qs = location.search;

            var params = [];
            var tokens;
            var re = /[?&]?([^=]+)=([^&]*)/g;

            while (tokens = re.exec(qs)) {
                if (decodeURIComponent(tokens[1]) == name)
                    params.push(decodeURIComponent(tokens[2]));
            }

            return params;
        }

        function buttonSearch(elem=null) {
            if (elem != null) {
                if (elem.id == "key2") {
                    var pars = document.getElementById("key1").getAttribute("name") + '=' + document.getElementById("key1").value.trim();
                    pars += '&' + elem.getAttribute("name") + '=' + elem.value.trim();
                } else {
                var pars = elem.getAttribute("name") + '=' + elem.value.trim();
                }

                document.location.href = '?' + pars + get_lang();

            } else {
                var n = document.getElementById("selectID").options.selectedIndex;
                var par = document.getElementById("selectID").options[n].value;

                document.location.href = '?q=' + encodeURIComponent(document.getElementById('q').value.trim()) + get_lang() + '&search=' + par;
            }
        }

        function start() {

            params = parseUrlQuery();

            document.getElementById('main').innerHTML = '';
            if (params['lang'] == null) params['lang'] = "en";

        //	document.getElementById('home').href = document.location.pathname;
            document.getElementById('home').href = '?blocks&lang=' + params['lang'];
            document.getElementById('menu_transactions').href = '?transactions&lang=' + params['lang'];
            document.getElementById('menu_exchange').href = '?exchange&lang=' + params['lang'];
            document.getElementById('menu_order').href = '?order&lang=' + params['lang'];
            document.getElementById('menu_addresses').href = '?addresses&lang=' + params['lang'];
            document.getElementById('menu_persons').href = '?persons&lang=' + params['lang'];
            document.getElementById('menu_polls').href = '?polls&lang=' + params['lang'];
            document.getElementById('menu_assets').href = '?assets&lang=' + params['lang'];
            document.getElementById('menu_statuses').href = '?statuses&lang=' + params['lang'];
            document.getElementById('menu_templates').href = '?templates&lang=' + params['lang'];
            document.getElementById('menu_owners').href = '?owners&lang=' + params['lang'];
            document.getElementById('menu_peers').href = '?peers&lang=' + params['lang'];

            document.getElementById('menuBlocks').setAttribute('class', '');
            document.getElementById('menuAddresses').setAttribute('class', '');
            document.getElementById('menuOwners').setAttribute('class', '');
            document.getElementById('menuPolls').setAttribute('class', '');
            document.getElementById('menuAssets').setAttribute('class', '');
            document.getElementById('menuStatuses').setAttribute('class', '');
            document.getElementById('menuTemplates').setAttribute('class', '');
            document.getElementById('menuTransactions').setAttribute('class', '');
            document.getElementById('menuExchange').setAttribute('class', '');
            document.getElementById('menuOrder').setAttribute('class', '');

            var title = 'Erachain BlockExplorer';

            if (document.location.search) {
                asyncAjax('blockexplorer.json' + location.search);
                return;
            }

            location.search = '?blocks';
            asyncAjax('blockexplorer.json?blocks&start=' + params['start'] + '&lang=' + params['lang']);

        }

        function Lang_setting() {
            var data = {};
            var k = 0;
            a = document.location;
            b = document.location.search;
            search = "?";
            var n = document.getElementById("Langs").options.selectedIndex;
            var val = document.getElementById("Langs").options[n].value;
            if (document.location.search) {
                var pair = (location.search.substr(1)).split('&');
                for (var i = 0; i < pair.length; i++) {
                    if (i != 0) {
                        search += '&';
                    }
                    var param = pair[i].split('=');
                    if (param[0] == 'lang') {
                        k = 1;

                        search += 'lang=' + val;
                    } else {
                        search += param[0] + '=' + param[1];

                    }
                }
                if (k == 0) {
                    search += '&lang=' + val;
                }
            } else {
                search += 'lang=' + val;
            }

            url = document.location.origin + document.location.pathname + search;
            document.location.href = document.location.origin + document.location.pathname + search;
        }

    </script>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta name="http-equiv" content="Content-type: text/html; charset=UTF-8">
</head>
<body onload='start()' topmargin="0" leftmargin="0" rightmargin="0" bottommargin="0" style='height:100%'>

<table id="all" width="100%" cellspacing="0" cellpadding="0" border="0">
    <tr>
        <td valign="top" align="" colspan="3" height="1" nowrap>
            <!-- <nav class="navbar navbar-default navbar-fixed-top"> -->
            <div class="container-fluid">
                <div class="navbar-header">
                    <button type="button" data-toggle="collapse" data-target="#navbar" aria-expanded="false"
                            aria-controls="navbar" class="navbar-toggle collapsed"><span class="sr-only">Toggle navigation</span><span
                            class="icon-bar"></span><span class="icon-bar"></span><span class="icon-bar"></span>
                    </button>
                    <a href="http://erachain.org" class="navbar-brand"><img src="img/logo_header.svg"
                                                                            style="height:50px" alt=""
                                                                            class="logo-header"></a>
                    <b><span id="network" style="color:red;"></span></b>
                </div>
                <div id="navbar" class="navbar-collapse collapse">
                    <!--    <ul class="nav navbar-nav navbar-right">
           <li><a id=home href=''>Scanner</a></li>

		<li class="dropdown"><a href="#" data-toggle="dropdown" role="button" aria-expanded="false" class="dropdown-toggle"><span class="glyphicon glyphicon-th"></span></a>
          <div role="menu" class="dropdown-menu">
            <div class="menu-grid">
              <div class="list">
                <div class="row">
					<div class="col-sm-4 col-xs-6"><a href="/index/webdirectory.html">
                      <div class="menu"><span class="glyphicon glyphicon-globe"></span><a href="/index/webdirectory.html">Webdirectory</a></div></a></div>
					<div class="col-sm-4 col-xs-6"><a href="/index/blogdirectory.html">
                      <div class="menu"><span class="glyphicon glyphicon-list"></span><a href="/index/blogdirectory.html">Blogdirectory</a></div></a></div>
                  <div class="col-sm-4 col-xs-6"><a href="/index/blog.html">
                      <div class="menu"><span class="glyphicon glyphicon-edit"></span><a href="/index/blog.html">Blog</a></div></a></div>
                  <div class="col-sm-4 col-xs-6"><a href="/index/namestorage.html">
                      <div class="menu"><span class="glyphicon glyphicon-file"></span><a href="/index/namestorage.html">NameStorage</a></div></a></div>
					<div class="col-sm-4 col-xs-6"><a href="/index/hashtag.html?hashtag=ERA">
                      <div class="menu"><span class="glyphicon glyphicon-fire"></span><a href="/index/hashtag.html?hashtag=ERA">Hashtag</a></div></a></div>
                </div>
              </div>
            </div>
          </div>
        </li>

          </ul>-->
                    <div class="navbar-form navbar-left">
                        <div class="input-group">
                            <select id="selectID" class="form-control" role="tablist">
                                <option value=blocks id=home_op translate="true">Block</option>
                                <option value=exchange id=menu_exchange_op translate="true">Exchange</option>
                                <option value=transactions id=menu_transactions_op translate="true">Transaction</option>
                                <option value=addresses id=menu_addresses_op translate="true">Address</option>
                                <option value=assets id=menu_assets_op translate="true">Asset</option>
                                <option value=persons id=menu_persons_op translate="true">Person</option>
                                <option value=polls id=menu_polls_op translate="true">Poll</option>
                                <option value=statuses id=menu_statuses_op translate="true">Status</option>
                                <option value=templates id=menu_templates_op translate="true">Template</option>
                                <option value=owners id=menu_owners_op translate="true">Owners</option>
                                <option value=order id=menu_order_op translate="true">Order</option>
                            </select>
                        </div>
                        <div class="input-group">
                            <input id="q" size="70" type="text" value="" class="form-control"
                                   onkeydown="if (event.keyCode == 13) buttonSearch()">
                            <span class="input-group-btn">
                                <button id="button" type="button" value="!searchval!" class="btn btn-link"
                                        onClick="buttonSearch()"><span class="glyphicon glyphicon-search"></span><span
                                        class="sr-only">Search</span></button></span>
                        </div>
                        <select id="Langs" OnChange="Lang_setting()" class="form-control">
                        </select>
                    </div>
                    <div class="navbar-form navbar-right">
                        <button type="button" class="btn" data-toggle="modal" data-target="#qrModal">QR</button>
                    </div>
                </div>
            </div>


            <div class="container-fluid">
                <div class="row">
                    <div class="main-tabs">
                        <div class="container" style="width: 1300px;">
                            <div class="row" id="main-menu">
                                <ul role="tablist" class="nav nav-tabs" style="font-size:1.1em;">
                                    <li id=menuBlocks><a href="?blocks" id=home translate="true">Blocks</a></li>
                                    <li id=menuTransactions><a href="?transactions" id=menu_transactions
                                                               translate="true">Transactions</a></li>
                                    <li id=menuExchange><a href="?exchange" id=menu_exchange
                                                           translate="true">Exchange</a></li>
                                    <li id=menuAddresses><a href="?addresses" id=menu_addresses translate="true">Addresses</a>
                                    </li>
                                    <li id=menuPersons><a href="?persons" id=menu_persons translate="true">Persons</a>
                                    </li>
                                    <li id=menuPolls><a href="?polls" id=menu_polls translate="true">Polls</a></li>
                                    <li id=menuAssets><a href="?assets" id=menu_assets translate="true">Assets</a></li>
                                    <li id=menuStatuses><a href="?statuses" id=menu_statuses
                                                           translate="true">Statuses</a></li>
                                    <li id=menuTemplates><a href="?templates" id=menu_templates translate="true">Templates</a>
                                    </li>
                                    <li id=menuOwners><a href="?owners" id=menu_owners translate="true">Owners</a>
                                    </li>
                                    <li id=menuOrder><a href="?order" id=menu_order translate="true">Order</a></li>
                                    <li id=menuPeers><a href="?peers" id=menu_peers translate="true">Peers</a></li>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- </nav> -->
        </td>
    </tr>
    <td colspan="3" valign="top" align="center" width="100%">

        <br>

        <div id="loading" style='display:none;'><img src="img/loading.gif" alt="Banner"/></div>

        <div id='main'></div>

    </td>
    </tr>
</table>


<table border="0" width="100%" cellspacing=0 cellpadding=0>
    <tr valign="bottom">
        <td align="center" style='padding-top:15px; padding-bottom:5px;'>
            <a href=http://erachain.org>
                <img border="0" src="img/logo_bottom.svg" height="50"/>
                <!--	<b><span style="font-size:40px;text-shadow:1px 1px 2px black, 0em 0em 0em #00F1FF;"><span style="color:chartreuse;">ER</span><span style="color:gold;">A</span></b> -->
            </a>
        </td>
    </tr>
</table>

<div class="modal" id="qrModal" tabindex="-1" role="dialog">
    <div class="modal-dialog" role="document" style="top: 20%">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">QR</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <p>
                <div id="qr"></div>
                </p>
                <script type="text/javascript">new QRCode(document.getElementById("qr"), location.href);</script>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

</body>

</html>
